# Changelog
All notable changes to casting-expert will be documented in this file.

## [0.1.7] - 2024-03-12

### Added
- ✨ CLI support with multiple input/output options
- 🎯 Extended audience support for different user groups
- 📦 Optional dependencies:
  - YAML support (`[yaml]`)
  - Data science tools (`[data]`)
  - Web development tools (`[web]`)
  - Development tools (`[dev]`)
  - Full installation option (`[full]`)
- 📄 Comprehensive documentation for all user groups
- 🔄 Multiple format output support (JSON, YAML, Python)
- 💅 Pretty printing options in CLI
- 📥 Standard input support in CLI
- 📂 File input/output support

### Changed
- 🔧 Improved folder structure
- 📁 Moved parsers to casters directory
- ⚡️ Enhanced parsing performance
- 🏗️ Updated project structure for better organization
- 📝 Extended classifiers for PyPI
- 📚 Improved documentation with audience-specific examples
- 🎨 Reorganized code structure for better maintainability

### Fixed
- 🐛 Quote handling in string parsing
- 🔍 Nested structure parsing
- 📋 Error reporting in CLI
- 🏷️ Package metadata and classifiers

## [0.1.6] - 2024-03-05

### Added
- 🎯 Type inference capabilities
- 🔍 Advanced validation rules
- 📊 Data serialization options

### Changed
- ⚡️ Improved parsing performance
- 🔧 Enhanced error messages
- 📝 Updated documentation

### Fixed
- 🐛 Bug in nested dictionary parsing
- 🔍 Type inference edge cases
- 📋 Validation error messages

## [0.1.5] - 2024-02-28

### Added
- 🎯 Basic type casting functionality
- 📝 Initial documentation
- ✅ Basic validation rules

### Changed
- 🔧 Code structure improvements
- 📚 Documentation updates

## [Unreleased]
### Added
- 🔄 Streaming support for large files
- 🌐 Network data handling
- 📊 Advanced data visualization

### Changed
- ⚡️ Performance optimizations
- 🔧 Enhanced error handling

### Deprecated
- 📛 Old parsing methods (to be removed in 0.2.0)

### Removed
- 🗑️ Legacy validation functions

### Fixed
- 🐛 Memory usage in large file processing
- 🔍 Type inference accuracy

### Security
- 🔒 Input validation improvements